<?php
/*-----------------------------------------------------------------
* 	ID:						cseov26_qf1.php
* 	Letzter Stand:			v2.5
* 	zuletzt geaendert von:	akausch
* 	Datum:					2014/04/08
*
* 	Copyright (c) since 2010 commerce:SEO by Webdesign Erfurt
* 	http://www.commerce-seo.de
* ---------------------------------------------------------------*/

class cseov26_qf1 {
var $title, $output;

function cseov26_qf1() {
  $this->code = 'cseov26_qf1';
  $this->version = '2.6.1';
  $this->title = 'cseov26_qf1';
  $this->description = 'FixPack 6.1 für commerce:seo v2next 2.5.16';
  $this->enabled = ((MODULE_CSEO_V26QF1_STATUS == 'true') ? true : false);
  $this->sort_order = MODULE_CSEO_V26QF1_SORT_ORDER;

  $this->output = array();
}

function process() {
  global $order, $xtPrice;
}

function check() {
  if (!isset($this->_check)) {
	$check_query = xtc_db_query("SELECT configuration_value FROM " . TABLE_CONFIGURATION . " WHERE configuration_key = 'MODULE_CSEO_V26QF1_STATUS'");
	$this->_check = xtc_db_num_rows($check_query);
  }
  return $this->_check;
}

function keys() {
	return array('MODULE_CSEO_V26QF1_STATUS', 'MODULE_CSEO_V26QF1_SORT_ORDER');
}

function install() {
	xtc_db_query("INSERT INTO " . TABLE_CONFIGURATION . " (configuration_key, configuration_value,configuration_group_id, sort_order, set_function, date_added) VALUES ('MODULE_CSEO_V26QF1_STATUS', 'true', '6', '1','', now())");
	xtc_db_query("INSERT INTO " . TABLE_CONFIGURATION . " (configuration_key, configuration_value,configuration_group_id, sort_order, date_added) VALUES ('MODULE_CSEO_V26QF1_SORT_ORDER', '1','6', '2', now())");
	xtc_db_query("INSERT INTO " . TABLE_CONFIGURATION . " (configuration_key, configuration_value,configuration_group_id, sort_order, date_added) VALUES ('MODULE_CSEO_V26QF1', 'true','6', '3', now())");
	$check_query = xtc_db_query("SELECT configuration_key FROM " . TABLE_CONFIGURATION . "  WHERE configuration_key = 'SMTP_ENCRYPTION';");
	if (xtc_db_num_rows($check_query) == 0) {
		xtc_db_query("INSERT INTO configuration VALUES ('', 'SMTP_ENCRYPTION', 'true', 12, 9, NULL, NOW(), NULL, \"xtc_cfg_select_option(array('true', 'ssl', 'tls'),\");");
	}
	$check_query = xtc_db_query("SELECT configuration_key FROM " . TABLE_CONFIGURATION . "  WHERE configuration_key = 'SEARCH_PRODUCT_NAMES';");
	if (xtc_db_num_rows($check_query) == 0) {
		xtc_db_query("INSERT INTO configuration VALUES ('', 'SEARCH_PRODUCT_NAMES', 'true', 22, 8, NULL, NOW(), NULL, \"xtc_cfg_select_option(array('true', 'false'),\");");
	}
	$check_query = xtc_db_query("SELECT configuration_key FROM " . TABLE_CONFIGURATION . "  WHERE configuration_key = 'SEARCH_PRODUCT_EAN';");
	if (xtc_db_num_rows($check_query) == 0) {
		xtc_db_query("INSERT INTO configuration VALUES ('', 'SEARCH_PRODUCT_EAN', 'true', 22, 8, NULL, NOW(), NULL, \"xtc_cfg_select_option(array('true', 'false'),\");");
	}
	$check_query = xtc_db_query("SELECT configuration_key FROM " . TABLE_CONFIGURATION . "  WHERE configuration_key = 'SEARCH_PRODUCT_MODEL';");
	if (xtc_db_num_rows($check_query) == 0) {
		xtc_db_query("INSERT INTO configuration VALUES ('', 'SEARCH_PRODUCT_MODEL', 'true', 22, 8, NULL, NOW(), NULL, \"xtc_cfg_select_option(array('true', 'false'),\");");
	}
	if (!column_exists ('orders_products_attributes','orders_products_options_id')) {
		xtc_db_query("ALTER TABLE `orders_products_attributes` ADD `orders_products_options_id` INT(11) NOT NULL;");
	}
	if (!column_exists ('orders_products_attributes','orders_products_options_values_id')) {
		xtc_db_query("ALTER TABLE `orders_products_attributes` ADD `orders_products_options_values_id` INT(11) NOT NULL;");
	}

	if (!table_exists ('contact_mail')) {
		xtc_db_query("
		CREATE TABLE `contact_mail` (
		  `contact_id` int(11) NOT NULL AUTO_INCREMENT,
		  `customers_id` int(11) NOT NULL,
		  `entry_name` varchar(64) NOT NULL,
		  `entry_email` varchar(64) NOT NULL,
		  `entry_message` TEXT DEFAULT NULL,
		  `entry_datensg` int(1) NOT NULL DEFAULT '0',
		  `entry_contact_send` datetime DEFAULT '0000-00-00 00:00:00',
		  PRIMARY KEY (`contact_id`),
		  KEY `idx_contact_id` (`contact_id`)
		) ENGINE=MyISAM DEFAULT CHARSET=utf8;");
		xtc_db_query("ALTER TABLE admin_access ADD contact_mail INT( 1 ) NOT NULL DEFAULT 0;");
		xtc_db_query("UPDATE admin_access SET contact_mail = '1';");
		$check_query = xtc_db_query("SELECT name FROM admin_navigation WHERE name = 'contact_mail';");
		if (xtc_db_num_rows($check_query) == 0) {
			$lang_other = xtc_db_query("SELECT languages_id FROM languages;");
			if (xtc_db_num_rows($lang_other) > 0) {
				while ($other_lang = xtc_db_fetch_array($lang_other)) {
					$language_id = $other_lang['languages_id'];
					xtc_db_query("INSERT INTO admin_navigation VALUES ('', 'contact_mail', 'Kontakt E-Mails', 'customers', 'contact_mail.php', '', ".$language_id.", '', 1);");
				}
			}
		}			
	}
	
	$check_query = xtc_db_query("SELECT name FROM admin_navigation WHERE name = 'paypal_config';");
	if (xtc_db_num_rows($check_query) == 0) {
		$lang_other = xtc_db_query("SELECT languages_id FROM languages;");
		if (xtc_db_num_rows($lang_other) > 0) {
			while ($other_lang = xtc_db_fetch_array($lang_other)) {
				$language_id = $other_lang['languages_id'];
				xtc_db_query("INSERT INTO admin_navigation VALUES ('', 'paypal_config', 'PayPal Plus', 'config', 'paypal_config.php', '', ".$language_id.", '', 1);");
			}
		}
	}
	xtc_db_query("UPDATE database_version SET version = 'commerce:seo v2next 2.6.1'");
}

function remove() {
  xtc_db_query("DELETE FROM " . TABLE_CONFIGURATION . " WHERE configuration_key in ('" . implode("', '", $this->keys()) . "')");
  xtc_db_query("DELETE FROM " . TABLE_CONFIGURATION . " WHERE configuration_key = 'MODULE_CSEO_V26QF1'");
  xtc_db_query("DELETE FROM " . TABLE_CONFIGURATION . " WHERE configuration_key = 'FREE_SHIPPING_LOCAL_ONLY'");
  xtc_db_query("UPDATE database_version SET version = 'commerce:seo v2next 2.5.16'");
}

}
